*
* READER.PRG
*
* Visual dBase "READER" program (for SEE 3.0)
*
* This program logs onto POP3 server 'Pop3Server' and downloads
* message number 'MsgNbr' into directory 'EmailDir' as a file named
* 'EmailName'. Any attachment is downloaded into directory 'AttachDir'.
*
* PROGRAMMER:
*   Set the variables 'Pop3Server', 'Pop3UserName', 'Pop3Password', and
*   'MsgNbr', etc. below before compiling.  Also edit the following INCLUDE
*   commands with the location of SEE32.CC and KEYCODE.CC

#INCLUDE C:\TEMP\SEE32.CC
#INCLUDE C:\TEMP\KEYCODE.CC

*** PROGRAMMER: Edit these strings [use host name or IP address for server] ***
Pop3Server = "10.0.0.1"
Pop3UserName = "mike"
Pop3Password  = "mike"
DiagFile = "C:\TEMP\reader.log"
***MsgNbr = 1
* Note 1: do NOT use pathname in EmailName
EmailName = "email.txt"
* Note 2: use full path names unless file is located in dBase directory
EmailDir = "C:\TEMP"
AttachDir = "C:\TEMP"
*** END PROGRAMMER ***

? "READER 2/16/2000"
if seeAttach(1, SEE_KEY_CODE) < 0
  ? "Cannot attach SEE"
  return
endif
Code = seeStringParam(0,SEE_LOG_FILE, DiagFile)
* set maximum connect wait to 10 seconds
Code = seeIntegerParam(0, SEE_CONNECT_WAIT, 10000)
* connect to POP3 server
? "Connecting to " + Pop3Server
Code = seePop3Connect(0,Pop3Server, Pop3UserName, Pop3Password)
if Code < 0
  Temp = SPACE(128)
  Code = seeErrorText(0,Code,Temp,128)
  ? Left(Temp,Code)
else
  * get # messages waiting
  ? "Getting message status..."
  NbrMessages = seeGetEmailCount(0)
  if NbrMessages < 0
    Temp = SPACE(128)
    Code = seeErrorText(0,NbrMessages,Temp,128)
    ? Left(Temp,Code)
  else
    ? NbrMessages," messages waiting."
    If NbrMessages = 0
      Code = seeClose(0)
      Code = seeRelease()
      return
    Endif
    ? "Enter message # to read (and delete):"
    MsgNbr = AcceptInteger()
    If (MsgNbr>0) And (MsgNbr <= NbrMessages)
      ? "Reading Message ", LTRIM(STR(MsgNbr)), ", please wait..."
      Code = seeGetEmailFile(0, MsgNbr, EmailName, EmailDir, AttachDir)
      if Code < 0
        Temp = SPACE(128)
        Code = seeErrorText(0,Code,Temp,128)
        ? Left(Temp,Code)
        Code = seeClose(0)
        Code = seeRelease()
        return
      endif
      ? "Saved as ", LTRIM(EmailName)
      * get list of attachment file names
      Buffer = SPACE(1024)
      Code = seeDebug(0, SEE_GET_ATTACH_NAMES, Buffer, 1024)
      if Code > 0
        ? "Attachment names are:"
        ? Left(Buffer, Code)
      endif
      * deleting message from server
      Code = seeDeleteEmail(0, MsgNbr)
      ? "Message ",  LTRIM(STR(MsgNbr)), " deleted from server."
    endif
  endif
endif
? "Done."
Code = seeClose(0)
Code = seeRelease()
return

Function AcceptInteger()
Value = 0
DO While true
  X = InKey(0)
  ?? Chr(X)
  If (X >= Asc("0")) And (X <= Asc("9"))
    Value = 10 * Value + (X - Asc("0"))
  else
    exit
  endif
Enddo
return Value

