*
* STATUS2.PRG
*
* Visual dBase "STATUS" program (for SEE 3.2) that uses seeDriver.
*
* Note that the 4th argument to seeGetEmailLines is 0 rather than
* a buffer, which will force SEE to use its internal memory. This
* is necessary since otherwise dBase may move its memory at runtime.
* After seeDriver completes running, the SEE internal buffer can be
* copied using seeDebug(Chan, SEE_COPY_BUFFER, ...).
*
* This precaution is ONLY necessary when using the SEE driver seeDriver.
* Compare this program to STATUS.PRG.
*
* PROGRAMMER:
*   Set the variables 'Pop3Server', 'Pop3UserName', and
*   'Pop3Password' below before compiling.  Also edit the
*   following INCLUDE commands with the location of
*   SEE32.CC and KEYCODE.CC

#INCLUDE C:\TEMP\SEE32.CC
#INCLUDE C:\TEMP\KEYCODE.CC

*** PROGRAMMER: Edit these strings [use host name or IP address for server] ***
Pop3Server = "10.0.0.1"
Pop3UserName = "mike"
Pop3Password  = "mike"
DiagFile = "C:\TEMP\status2.log"
*** END PROGRAMMER ***

? "DRIVER 2/16/2000"
if seeAttach(1, SEE_KEY_CODE) < 0
  ? "Cannot attach SEE"
  return
endif
Code = seeStringParam(0,SEE_LOG_FILE, DiagFile)
* connect to POP3 server
? "Connecting to " + Pop3Server
* set maximum connect wait to 10 seconds
Code = seeIntegerParam(0, SEE_CONNECT_WAIT, 10000)
Code = seePop3Connect(0,Pop3Server, Pop3UserName, Pop3Password)
if Code < 0
  Code = seeErrorText(0,Code,Buffer,128)
  ? Left(Buffer,Code)
else
  * get # messages waiting
  ? "Getting message status..."
  NbrMsg = seeGetEmailCount(0)
  if NbrMsg < 0
    Code = seeErrorText(0,NbrMsg,Buffer,128)
    ? Left(Buffer,Code)
  else
    ? NbrMsg," messages waiting."
    For I = 1 to NbrMsg
      ? "----- Message ", LTRIM(STR(I)) + " -----"
      * disable AUTO CALL
      Code = seeIntegerParam(0, SEE_AUTO_CALL_DRIVER, 0)

      ********************************************************
      * use internal SEE memory (pass 0 as 4th argument)     *
      * since dBase may move memory it allocates at runtime. *
      ********************************************************
      Code = seeGetEmailLines(0, I, 0, 0, 3000)

      Do while .T.
        Code = seeDriver(0)
        if Code = 0
          Exit
        endif
        if Code < 0
          Temp = SPACE(128)
          Code = seeErrorText(0,Code,Temp,128)
          ? Left(Temp,Code)
          Code = seeClose(0)
          Code = seeRelease()
          return
        endif
        nBytes = seeStatistics(0,SEE_GET_TOTAL_BYTES_READ)
        ? nBytes, " bytes read"
      Enddo
      * re-enable AUTO CALL
      Code = seeIntegerParam(0, SEE_AUTO_CALL_DRIVER, 1)
      * copy internal SEE memory buffer
      Buffer = SPACE(3000)
      Code = seeDebug(0, SEE_COPY_BUFFER, Buffer, 3000)
      * display "DATE: " line
      Temp = SPACE(128)
      Code = seeExtractText(Buffer, "Date: ", Temp, 128)
      if Code > 0
        ? Left(Temp,Code)
      endif
      * display "FROM: " line
      Temp = SPACE(128)
      Code = seeExtractText(Buffer, "From: ", Temp, 128)
      if Code > 0
        ?? Left(Temp,Code)
      endif
      * display "SUBJECT: " line
      Temp = SPACE(128)
      Code = seeExtractText(Buffer, "Subject: ", Temp, 128)
      if Code > 0
        ?? Left(Temp,Code)
      endif
    Endfor
   ? "----- END -----"
  endif
endif
? "Done."
Code = seeClose(0)
Code = seeRelease()
return

